segment .data
    message: db "Potatoes: %f, Leeks: %f",10,0
                        ;  Potatoes, Leeks
    num_ingredients:    dq 10.0,      5.0 ; This plus...
    num_cooks:          dq  2.0,      2.0 ; This times...
    ingredients_cook:   dq  3.0,      1.0 ; This!
    ; ie,                ->16.0   and 7.0

segment .text
    global main
    extern printf

main:
    push    rbp

    ; Load our variables, packed 2 at a time
    movupd  xmm0, [num_ingredients]
    movupd  xmm1, [num_cooks]
    movupd  xmm2, [ingredients_cook]

    ; FMA: num_ingredients[i] = n_i[i] + (n_cooks * i_per_cook)
    ; for i 0..1 (xmm registers fit 2 double floats at idx 0 and 1)
    vfmadd231pd xmm0, xmm1, xmm2

    ; Send back to ram
    movupd  [num_ingredients], xmm0

    ; Print
    mov     rdi, message
    movupd  xmm0, [num_ingredients]
    movupd  xmm1, [num_ingredients+8]
    call    printf wrt ..plt
    mov     rax, 0

    ; Quit
    pop     rbp
    ret
